/***************************************************************************
                          apaintBoundary.h  -  description
                             -------------------
    begin                : Tue Aug 3 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qptrlist.h>

#ifndef APAINT_BOUNDARY_H
#define APAINT_BOUNDARY_H

class QImage;

typedef struct 
  {
    int     x1;
    int     y1;
    int     x2;
    int     y2;
    bool    open;
    bool    visited;
  } BoundSeg;

typedef QPtrList<BoundSeg> BoundSegList;  
  
class Boundary
{
public:
  // mask = bitMask, px,py = translate position, numNoundSeg = returned number of segments
  static BoundSeg* generate_boundary(QImage *mask, int px, int py, int &numBoundSeg);
  
private:
   Boundary(int wid);
   ~Boundary();

   void find_empty_segs(QImage  *mask,
                     int          scanline,
                     int          *empty_segs,
                     int         &num_empty);
   void make_seg (int x1, int y1, int x2, int y2, bool open);
   void process_horiz_seg (int x1, int y1, int x2, int y2, bool open);
   void make_horiz_segs(int start, int end, int scanline, int *empty, int num_empty, int top);
   
private:
  /*  The array of vertical segments  */
  int      *vert_segs;

/* static empty segment arrays */
  int      *empty_segs_n;
  int      *empty_segs_c;
  int      *empty_segs_l;
  int      num_empty_n, num_empty_c, num_empty_l;
  int       max_empty_segs;

  BoundSegList boundList;                                 
};

#endif
