/***************************************************************************
                          drawinginrepeatdlg.h  -  description
                             -------------------
    begin                : Tue Sep 16 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DRAWINGINREPEATDLG_H
#define DRAWINGINREPEATDLG_H

#include <dialog_ui_drawInRepeat.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include "apaintdoc.h"

class ApaintDoc;
class ApaintView;

class DrawingInRepeatDlg : public DrawingInRepeatDialogUI  {
  Q_OBJECT
public: 
	DrawingInRepeatDlg(QWidget *parent, const char *name, ApaintDoc *docp);
	~DrawingInRepeatDlg();

  void showDlg();
  
signals:
  void refreshSig(int x, int y, int w, int h);
  void setTileUndo();

  
protected slots:
  void setRepeatMode(int mode);
  void okBtnClicked();
  void cancelBtnClicked();
  void setRepX(int wid);
  void setRepY(int hei);
  void offsetChanged(int val);
  void setOffset(int indx);
  void mousePressedSlot(QMouseEvent *e, QPainter *pc);
  void zoomChangedSlot(double zx, double zy);
  void setNewImage();
  void layerChangedSlot(Layer *layer);
  
public:
  enum RepeatMode{Brick, HorMove, VertMove};

  RepeatMode getRepeatMode();
  int getRepX() {return sbRepTimesWid->value();}
  int getRepY() {return sbRepTimesHei->value();}
  int getOffset() {return sbOffset->value();}
  void doit() {okBtnClicked();}

protected:
  void setViewWid(int wid);
  void setViewHei(int hei);
  bool doNewImage() {return cbNewImage->isChecked();}
  void setUpLayer(ApaintDoc *adoc, int offset);
  void refreshRect(QRect r);
  void resetDocTiles(ApaintDoc *d);
  void setupDialog();

private:
  void copyTileData(Layer *dst, Layer *src);
  void setLayerTiles(Layer *layer, int offset);

  RepeatMode rmode;
  QVBoxLayout *vbox;
  ApaintDoc *doc, *previewDoc;
  ApaintView *preview;
  Layer *mainLayer;
  int repx, repy;
  QRect pviewPos, origPos;
  int offsetMain, offsetPreview;
  double scaleX, scaleY;
  bool makeNewImage;
};

#endif
