/***************************************************************************
                          recttool.h  -  description
                             -------------------
    begin                : pet feb 28 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RECTTOOL_H
#define RECTTOOL_H

#include <toolbase.h>
#include <qpainter.h>
#include <math.h>
#include <qbrush.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qcheckbox.h>

enum RectType{NormalRect, QuadRect, EllipseRect, CircleRect};

class DrawInRepeat;
class ApaintDoc;

class RectTool;

class RectProp: public QWidget {
   Q_OBJECT
public:
   RectProp(QWidget *parent, const char *name);
   ~RectProp();
   int getRectX1() { return sbRectX1->value(); }
   int getRectY1() { return sbRectY1->value(); }
   int getRectX2() { return sbRectX2->value(); }
   int getRectY2() { return sbRectY2->value(); }
   int getRectWid() { return sbRectWid->value(); }
   int getRectHei() { return sbRectHei->value(); }
   void setRectX1(int value) { sbRectX1->setValue(value); }
   void setRectY1(int value) { sbRectY1->setValue(value); }
   void setRectX2(int value) { sbRectX2->setValue(value); }
   void setRectY2(int value) { sbRectY2->setValue(value); }
   void setRectWid(int value) { sbRectWid->setValue(value); }
   void setRectHei(int value) { sbRectHei->setValue(value); }
   void setTool(RectTool *tool) { rTool = tool; }
   void showFullXY(bool show);
   bool isFullX() const;
   bool isFullY() const;
public slots:  // This slots section is public
   void rectOKClicked();

private slots:
   void fullXToggled(bool);
   void fullYToggled(bool);

private:
  QCheckBox *cbFullX, *cbFullY;
  QSpinBox *sbRectX1, *sbRectY1, *sbRectX2, *sbRectY2, *sbRectWid, *sbRectHei;
  QPushButton *rectOK;
  RectTool *rTool;
};

class RectTool : public ToolBase  {
  Q_OBJECT
public: 
	RectTool(DrawInRepeat *drawp, ApaintDoc *docp, ToolType type, RectType rtype, PropObject *propObj);
	~RectTool();

 void drawParametric();
 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual bool doChangeTool(ToolChangeType chgType);
 virtual QPixmap getToolPix();
 virtual void showCommonProp(bool enable);

public slots:
 void lineSizeChgSlot(const QPen &pen){ lineWidth = pen.width(); }

signals:
 void showSize(QRect pos);
 void clearSize();
 
private:

 enum DrawType { NormalDraw, FillDraw};

 QRect getRect(int x1, int y1, int x2, int y2);
 void drawPrimitive(QPainter *pi, QRect r, bool doRefresh, bool useFg, bool final);
 
 int startx, starty;
 int lastx, lasty;
 int lineWidth;
 bool drawStarted;
 RectType typ;
 ButtonState btnPressed;
 DrawInRepeat *draw;
 DrawType drawType;
 QBrush noBrush, solidBrush, selBrush;
 ApaintDoc *doc;
 RectProp *rProp;
};

#endif
