/***************************************************************************
                          shiftimagetool.cpp  -  description
                             -------------------
    begin                : Sun Jun 15 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "toolShiftImage.h"
#include "apaintdrawrepeat.h"

extern char *getCommonPNG(const char *pixName);

ShiftImageTool::ShiftImageTool(DrawInRepeat *drawp, ToolType type, ApaintDoc *docp, ShiftType typ, PropObject *propObj):ToolBase(type, propObj)
{
 if (typ==HorShift)
  {
   setToggleBtn(QPixmap(getCommonPNG("cutY")), tr("Horizontal cut"));
   cur=QCursor(SplitHCursor);
  }
 else
  {
   setToggleBtn(QPixmap(getCommonPNG("cutX")), tr("Vertical cut"));
   cur=QCursor(SplitVCursor);
  }
 ltyp=typ;
 if (propObj)
  setUsepWidget(true);
 Q_CHECK_PTR(docp);
 Q_CHECK_PTR(drawp);
 doc = docp;
 draw = drawp; 
}

ShiftImageTool::~ShiftImageTool(){
}

void ShiftImageTool::mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi)
{
  int x, y;
  Layer *layer = doc->getLayer();
  if (!layer) return;
  
  int xi = (int)(e->x()/zoomX)-layer->layerPos().x();
  int yi = (int)(e->y()/zoomY)-layer->layerPos().y();

  if (layer->isUsingTiles())
    draw->transPoint(xi, yi, &x, &y);
  else
  {
    x = xi;
    y = yi;
  }
  
  if (ltyp == HorShift)
  {
    layer->horShift(x);
    doc->putUndoStack(ChangeLayerShiftX);
  }
  else
  {
    layer->vertShift(y);
    doc->putUndoStack(ChangeLayerShiftY);
  }
  doc->refreshLayer();
}

void  ShiftImageTool::mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi)
{
  drawPointer(pc, e->x(), e->y());
}

