/***************************************************************************
                          spraytool.h  -  description
                             -------------------
    begin                : Wed Mar 26 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPRAYTOOL_H
#define SPRAYTOOL_H

#include <toolbase.h>
#include <qpainter.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include "widget_ui_sprayProp.h"

class SprayPropWid: public SprayPropWidgetUI
{
  Q_OBJECT
public:
  SprayPropWid(QWidget *parent, const char *name);
  ~SprayPropWid(){};

  void setNumPoints(int num) { sbNumPoints->setValue(num);}
  void setRadius(int r) {sbRadius->setValue(r);}
  int getNumPoints() {return sbNumPoints->value();}
  int getRadius() {return sbRadius->value();}
  bool getFromCenter() {return cbFromCenter->isChecked();}
};
  
class DrawInRepeat;  
class ApaintDoc;
  
enum SprayType{ NormalSpray, MixSpray};
  
class SprayTool : public ToolBase  {
  Q_OBJECT
public: 
	SprayTool(DrawInRepeat *drawp, ToolType type, SprayType styp, ApaintDoc *docp, PropObject *propObj);
	~SprayTool();
    
 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void drawPointer(QPainter *p, int x, int y);
 virtual void begin();
 virtual void end();

 
protected slots:
 void drawPoints();
 void mixPoints();
    
private:
   uint getPixel(int x, int y, ApaintImage *img);
 
 bool drawStart;
 int xm, ym;
 QTimer *time;
 SprayType stype;
 bool useFg;
 ButtonState btnPressed;
 DrawInRepeat *draw;
 SprayPropWid *prop;
 ApaintDoc *doc;
 bool *protCol;
 bool aspectDrawSetting;
 int pointSize;
};

#endif
