

#ifndef WIDGETGUIDE_H
#define WIDGETGUIDE_H

#include <qframe.h>
#include <qrangecontrol.h>
#include "apaintview.h"

class QPixmap;
class Guide : public QWidget
{
  Q_OBJECT  
public:
  Guide(ApaintView *parent, ApaintDoc* _doc, Qt::Orientation _guideOrientation);

  void setBasePos();

    virtual ~Guide();
public slots:
  void slotZoomChanged(double zx, double zy);
  void viewMoving(int x, int y);
  void repaintSlot();
  void newDocSlot();
  
 signals:
  void movedSig();
protected:
    virtual void mousePressEvent(QMouseEvent* );
    virtual void mouseReleaseEvent(QMouseEvent* );
    virtual void mouseDoubleClickEvent(QMouseEvent* );
    virtual void mouseMoveEvent(QMouseEvent *e);
    virtual void paintEvent(QPaintEvent *);
    //virtual void updateMask();
private:
  
  QBitmap* makeBitmap(QPixmap* srcImg, QColor maskColor);
  void setColors();
  
  QRangeControl range;
  Orientation guideOrientation;
  int lastX;
  int lastY;
  int offsetX, offsetY;
  double zoomX;
  double zoomY;
  int posX;
  int posY;
  ApaintView* view;
  ApaintDoc* doc;
  
  QColor bcgColor;
  QColor lineColor;
};

#endif // WIDGETGUIDE_H
