/***************************************************************************
                          widgetIconView.h  -  description
                             -------------------
    begin                : Wed Apr 21 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef WIDGETICONVIEW_H
#define WIDGETICONVIEW_H
#include "qscrollview.h"

class IconList;

class IconListView: public QScrollView
{
  Q_OBJECT
public:
  IconListView(QWidget *parent, const char* name);
  ~IconListView();

  void setIconList(IconList *ilistp);
  void setupContents(bool refreshAll);
  void deleteImage();
  void refresh();
  void goLeft();
  void goRight();
  void goUp();
  void goDown();
  void pageUp();
  void pageDown();
  
signals:
  void iconSelected();
  void deleteImageSig();
  void renameImageSig();
  void iconSelectionChanged();
  
protected:
  virtual void drawContents(QPainter *p, int clipx, int clipy, int clipw, int cliph);
  virtual void contentsMousePressEvent (QMouseEvent *e );
  virtual void contentsMouseDoubleClickEvent (QMouseEvent *e );
  virtual void contentsMouseMoveEvent( QMouseEvent *e);  
  void viewportResizeEvent(QResizeEvent *re);
  virtual void keyPressEvent( QKeyEvent *e );

private:
 
 void changeSelected(int newSel, bool visible);
 void renameImage();
 void setToolTip(int iconNum);

 IconList *iList;
 int vwidth, vheight;
 int iconx, icony;
 bool iconsLoaded;
 int iconBelowMouse;
};

#endif
